/* 
   $Id: interface.c,v 1.7 2001/12/21 02:55:24 shibajun Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgse.

   sgse is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgse is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgse; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

static GnomeUIInfo file1_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_NEW_ITEM (N_("New"), NULL, on_new_file1_activate, NULL),
  GNOMEUIINFO_MENU_OPEN_ITEM (on_open1_activate, NULL),
  GNOMEUIINFO_MENU_SAVE_ITEM (on_save1_activate, NULL),
  GNOMEUIINFO_MENU_SAVE_AS_ITEM (on_save_as1_activate, NULL),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_EXIT_ITEM (on_exit1_activate, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo edit1_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_CUT_ITEM (on_cut1_activate, NULL),
  GNOMEUIINFO_MENU_COPY_ITEM (on_copy1_activate, NULL),
  GNOMEUIINFO_MENU_PASTE_ITEM (on_paste1_activate, NULL),
  GNOMEUIINFO_MENU_CLEAR_ITEM (on_clear1_activate, NULL),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_END
};

static GnomeUIInfo help1_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_ABOUT_ITEM (on_about1_activate, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar1_uiinfo[] =
{
  GNOMEUIINFO_MENU_FILE_TREE (file1_menu_uiinfo),
  GNOMEUIINFO_MENU_EDIT_TREE (edit1_menu_uiinfo),
  GNOMEUIINFO_MENU_HELP_TREE (help1_menu_uiinfo),
  GNOMEUIINFO_END
};

GtkWidget*
create_mainapp (void)
{
  GtkWidget *mainapp;
  GtkWidget *dock1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *button9;
  GtkWidget *button10;
  GtkWidget *button11;
  GtkWidget *scrolledwindow1;
  GtkWidget *text1;
  GtkWidget *appbar1;

  mainapp = gnome_app_new ("sgse", _("sgse"));
  gtk_object_set_data (GTK_OBJECT (mainapp), "mainapp", mainapp);

  dock1 = GNOME_APP (mainapp)->dock;
  gtk_widget_ref (dock1);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "dock1", dock1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dock1);

  gnome_app_create_menus (GNOME_APP (mainapp), menubar1_uiinfo);

  gtk_widget_ref (menubar1_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "file1",
                            menubar1_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "new_file1",
                            file1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "open1",
                            file1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "save1",
                            file1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "save_as1",
                            file1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "separator1",
                            file1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file1_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "exit1",
                            file1_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "edit1",
                            menubar1_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "cut1",
                            edit1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "copy1",
                            edit1_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "paste1",
                            edit1_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "clear1",
                            edit1_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit1_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "separator2",
                            edit1_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar1_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "help1",
                            menubar1_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help1_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "about1",
                            help1_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gnome_app_add_toolbar (GNOME_APP (mainapp), GTK_TOOLBAR (toolbar1), "toolbar1",
                                GNOME_DOCK_ITEM_BEH_EXCLUSIVE,
                                GNOME_DOCK_TOP, 1, 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (toolbar1), 1);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar1), 16);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar1), GTK_RELIEF_NONE);

#ifdef __SIKIGAMI__
#ifdef __SIKIGAMI_PDA__
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_NEW,
               SG_TOOLBAR_PIXMAP_SIZE_H,SG_TOOLBAR_PIXMAP_SIZE);
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_NEW,
               SG_TOOLBAR_PIXMAP_SIZE,SG_TOOLBAR_PIXMAP_SIZE);
#endif
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget (mainapp, GNOME_STOCK_PIXMAP_NEW);
#endif
  button1 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
#ifdef __SIKIGAMI__
                                NULL,
                                NULL, NULL,
#else
                                _("New"),
                                _("New"), NULL,
#endif
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);

#ifdef __SIKIGAMI__
#ifdef __SIKIGAMI_PDA__
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_OPEN,
               SG_TOOLBAR_PIXMAP_SIZE_H,SG_TOOLBAR_PIXMAP_SIZE);
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_OPEN,
               SG_TOOLBAR_PIXMAP_SIZE,SG_TOOLBAR_PIXMAP_SIZE);
#endif
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget (mainapp, GNOME_STOCK_PIXMAP_OPEN);
#endif
  button2 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
#ifdef __SIKIGAMI__
                                NULL,
                                NULL, NULL,
#else
                                _("Open"),
                                _("Open"), NULL,
#endif
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button2);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "button2", button2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button2);

#ifdef __SIKIGAMI__
#ifdef __SIKIGAMI_PDA__
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_SAVE,
               SG_TOOLBAR_PIXMAP_SIZE_H,SG_TOOLBAR_PIXMAP_SIZE);
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_SAVE,
               SG_TOOLBAR_PIXMAP_SIZE,SG_TOOLBAR_PIXMAP_SIZE);
#endif
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget (mainapp, GNOME_STOCK_PIXMAP_SAVE);
#endif
  button3 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
#ifdef __SIKIGAMI__
                                NULL,
                                NULL, NULL,
#else
                                _("Save"),
                                _("Save"), NULL,
#endif
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);

#ifdef __SIKIGAMI__
#ifdef __SIKIGAMI_PDA__
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_CUT,
               SG_TOOLBAR_PIXMAP_SIZE_H,SG_TOOLBAR_PIXMAP_SIZE);
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_CUT,
               SG_TOOLBAR_PIXMAP_SIZE,SG_TOOLBAR_PIXMAP_SIZE);
#endif
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget (mainapp, GNOME_STOCK_PIXMAP_CUT);
#endif
  button9 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
#ifdef __SIKIGAMI__
                                NULL,
                                NULL, NULL,
#else
                                _("Cut"),
                                _("Save"), NULL,
#endif
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button9);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "button9", button9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button9);

#ifdef __SIKIGAMI__
#ifdef __SIKIGAMI_PDA__
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_COPY,
               SG_TOOLBAR_PIXMAP_SIZE_H,SG_TOOLBAR_PIXMAP_SIZE);
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_COPY,
               SG_TOOLBAR_PIXMAP_SIZE,SG_TOOLBAR_PIXMAP_SIZE);
#endif
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget (mainapp, GNOME_STOCK_PIXMAP_COPY);
#endif
  button10 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
#ifdef __SIKIGAMI__
                                NULL,
                                NULL, NULL,
#else
                                _("Copy"),
                                _("Save"), NULL,
#endif
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button10);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "button10", button10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button10);

#ifdef __SIKIGAMI__
#ifdef __SIKIGAMI_PDA__
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_PASTE,
               SG_TOOLBAR_PIXMAP_SIZE_H,SG_TOOLBAR_PIXMAP_SIZE);
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size (mainapp, GNOME_STOCK_PIXMAP_PASTE,
               SG_TOOLBAR_PIXMAP_SIZE,SG_TOOLBAR_PIXMAP_SIZE);
#endif
#else
  tmp_toolbar_icon = gnome_stock_pixmap_widget (mainapp, GNOME_STOCK_PIXMAP_PASTE);
#endif
  button11 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
#ifdef __SIKIGAMI__
                                NULL,
                                NULL, NULL,
#else
                                _("Paste"),
                                _("Save"), NULL,
#endif
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button11);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "button11", button11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button11);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gnome_app_set_contents (GNOME_APP (mainapp), scrolledwindow1);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), text1);
  gtk_text_set_editable (GTK_TEXT (text1), TRUE);

  appbar1 = gnome_appbar_new (TRUE, TRUE, GNOME_PREFERENCES_NEVER);
  gtk_widget_ref (appbar1);
  gtk_object_set_data_full (GTK_OBJECT (mainapp), "appbar1", appbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (appbar1);
  gnome_app_set_statusbar (GNOME_APP (mainapp), appbar1);

  gnome_app_install_menu_hints (GNOME_APP (mainapp), menubar1_uiinfo);
  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (new_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                      GTK_SIGNAL_FUNC (open_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (cut_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button10), "clicked",
                      GTK_SIGNAL_FUNC (copy_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button11), "clicked",
                      GTK_SIGNAL_FUNC (paste_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (text1), "changed",
                      GTK_SIGNAL_FUNC (on_text1_changed),
                      NULL);

  return mainapp;
}

GtkWidget*
create_filesel_dialog (void)
{
  GtkWidget *filesel_dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *fileentry1;
  GtkWidget *combo_entry1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button4;
  GtkWidget *button6;

  filesel_dialog = gnome_dialog_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (filesel_dialog), "filesel_dialog", filesel_dialog);
  gtk_window_set_modal (GTK_WINDOW (filesel_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (filesel_dialog), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (filesel_dialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (filesel_dialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (filesel_dialog), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  fileentry1 = gnome_file_entry_new ("fsel", NULL);
  gtk_widget_ref (fileentry1);
  gtk_object_set_data_full (GTK_OBJECT (filesel_dialog), "fileentry1", fileentry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fileentry1);
  gtk_box_pack_start (GTK_BOX (vbox1), fileentry1, FALSE, FALSE, 0);
  gnome_file_entry_set_modal (GNOME_FILE_ENTRY (fileentry1), TRUE);

  combo_entry1 = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (fileentry1));
  gtk_widget_ref (combo_entry1);
  gtk_object_set_data_full (GTK_OBJECT (filesel_dialog), "combo_entry1", combo_entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry1);
  gtk_entry_set_text (GTK_ENTRY (combo_entry1), _("/raid1/home1/shibajun/sikigami/sgse/"));

  dialog_action_area1 = GNOME_DIALOG (filesel_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (filesel_dialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (filesel_dialog), GNOME_STOCK_BUTTON_OK);
  button4 = GTK_WIDGET (g_list_last (GNOME_DIALOG (filesel_dialog)->buttons)->data);
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (filesel_dialog), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (filesel_dialog), GNOME_STOCK_BUTTON_CANCEL);
  button6 = GTK_WIDGET (g_list_last (GNOME_DIALOG (filesel_dialog)->buttons)->data);
  gtk_widget_ref (button6);
  gtk_object_set_data_full (GTK_OBJECT (filesel_dialog), "button6", button6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button6);
  GTK_WIDGET_SET_FLAGS (button6, GTK_CAN_DEFAULT);

  return filesel_dialog;
}

GtkWidget*
create_about_dialog (void)
{
  const gchar *authors[] = {"sg@axe-inc.co.jp",
    NULL
  };
  GtkWidget *about_dialog;

  about_dialog = gnome_about_new ("sgse", VERSION,
                        _("(C) 2001-2002 AXE,Inc."),
                        authors,
                        _("SikiGami Simple Editor"),
                        NULL);
  gtk_object_set_data (GTK_OBJECT (about_dialog), "about_dialog", about_dialog);
  gtk_window_set_modal (GTK_WINDOW (about_dialog), TRUE);

  return about_dialog;
}

GtkWidget*
create_confirm_dialog (void)
{
  GtkWidget *confirm_dialog;
  GtkWidget *dialog_vbox2;
  GtkWidget *label7;
  GtkWidget *dialog_action_area2;
  GtkWidget *button7;
  GtkWidget *button8;

  confirm_dialog = gnome_dialog_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (confirm_dialog), "confirm_dialog", confirm_dialog);
  gtk_window_set_policy (GTK_WINDOW (confirm_dialog), FALSE, FALSE, TRUE);

  dialog_vbox2 = GNOME_DIALOG (confirm_dialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (confirm_dialog), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);
  gtk_widget_set_usize (dialog_vbox2, 230, -2);

  label7 = gtk_label_new (_("Text has been changed. save it?"));
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (confirm_dialog), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), label7, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

  dialog_action_area2 = GNOME_DIALOG (confirm_dialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (confirm_dialog), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area2), 8);

  gnome_dialog_append_button (GNOME_DIALOG (confirm_dialog), GNOME_STOCK_BUTTON_YES);
  button7 = GTK_WIDGET (g_list_last (GNOME_DIALOG (confirm_dialog)->buttons)->data);
  gtk_widget_ref (button7);
  gtk_object_set_data_full (GTK_OBJECT (confirm_dialog), "button7", button7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button7);
  GTK_WIDGET_SET_FLAGS (button7, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (confirm_dialog), GNOME_STOCK_BUTTON_NO);
  button8 = GTK_WIDGET (g_list_last (GNOME_DIALOG (confirm_dialog)->buttons)->data);
  gtk_widget_ref (button8);
  gtk_object_set_data_full (GTK_OBJECT (confirm_dialog), "button8", button8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button8);
  GTK_WIDGET_SET_FLAGS (button8, GTK_CAN_DEFAULT);

  return confirm_dialog;
}

